"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const _ = require("lodash");
const builtInModels = require("./models");
const mergeModels = require("@tradle/merge-models");
const utils = tslib_1.__importStar(require("./utils"));
exports.modelsPack = ({ namespace, models, lenses }) => {
    mergeModels()
        .add(builtInModels, { validate: false })
        .add(models);
    utils.pack({ namespace, models, lenses });
};
exports.bot = conf => {
    const { tours } = conf;
    if (tours) {
        _.each(tours, tour => utils.validateResource(tour));
    }
};
exports.style = style => utils.validateResource(style);
exports.terms = terms => {
    if (!terms.length) {
        throw new Error('terms and conditions cannot be empty');
    }
    const marked = require('marked');
    try {
        marked(terms);
    }
    catch (err) {
        throw new Error(`expected terms and conditions to be valid markdown: ${err.message}`);
    }
};
//# sourceMappingURL=validate.js.map